//ICC-TINYAVR application builder : 05.12.2009 23:30:01

// Target: TINY15

//ICC needs these helper files...
#include <iotiny15.h>
#include <macros.h>
#define ADC_VREF_TYPE 0x20

unsigned int volt;
unsigned char i;

#pragma interrupt_handler timer1_ovf_isr:5
void timer1_ovf_isr(void)
{
 TCNT1 = 0xF8;	//reload counter value
}

void delay_us(char delay)
{
  for (i=0; i<delay; i++) {};
}

void read_adc(unsigned char adc_input)
{
ADMUX=adc_input | (ADC_VREF_TYPE & 0xff);
// Delay needed for the stabilization of the ADC input voltage
delay_us(10);
// Start the AD conversion
ADCSR|=0x40;
// Wait for the AD conversion to complete
while ((ADCSR & 0x10)==0);
ADCSR|=0x10;
volt=ADCL;		//Read 8 low bits first (important)
volt|=(int)ADCH << 8;
}



//call this routine to initialise all peripherals
void init_devices(void)
{
 CLI();		//disable all interrupts
 
 //Adc init
 //ADCSR = 0x00;	//disable adc
 //ADMUX = 0x01;	//select adc input
 //ADCSR = 0xC4;
 PORTB = 0x00;	//portb bits
 DDRB  = 0x02;	//portb direction
  //Timer1 init
 //TCNT1 = 0xF8;	//count value
 OCR1A = 0x7F;	//PWM 50%
 //OCR1A=volt;
 OCR1B = 0xFF;	//frequency = 20Hz
 TCCR1 = 0x61;	//start Timer

 MCUCR = 0x00;
 GIMSK = 0x00;
 TIMSK = 0x02;
 TCNT1 = 0xF8;
 SEI();		//re-enable interrupts
}

//Application start
void main(void)
{
 init_devices();	//initialise periherals
 while(1)
 {
 //  portb_in();
 //  delay_us(255);
 //  read_adc(1);
  // portb_out();
 }		//loop forever
}

